<?php
// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array(
  'discuss',
  'style'
);

$specialtemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/adminfunctions_template.php');
require_once(DIR . '/discuss/includes/functions.php');
require_once(DIR . '/includes/class_bootstrap_framework.php');
vB_Bootstrap_Framework::init('../');
print_cp_header();
?>
<script type="text/javascript">
function actionCategory(box, id)
{
  var val = box.options[box.selectedIndex].value;
  if(val == 1)
     window.location = 'discuss_admin.php?do=categories&action=edit&catid=' + id;
  if(val == 2) {
    if(confirm('Are you sure that you want to Delete this Category?'))
      window.location = 'discuss_admin.php?do=categories&action=delete&catid=' + id;
  }
}
</script>
<?php
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'categories';
}
if ($_REQUEST['do'] == 'categories') {
    $vbulletin->input->clean_array_gpc('r', array(
		'catid'    			=> TYPE_UINT,
		'action'			=> TYPE_STR
    ));
    if(!isset($_REQUEST['catid']))
    {
       $catid = 0;
    } else {
       $catid = $_REQUEST["catid"];
    }
    if ($_REQUEST['action'] == 'insert')
    {
        // Get Category Drop List
        $tablename = "".TABLE_PREFIX."discuss_categories";
        $selectCat = new SelectCategory('parentid', $tablename, 'true');
        $selectCat->SetFirstOption('Root Category', 0);
        $selectCat->SetMultiple(false, 15);
        $selectCat->SetStyle('width:330px; font-size:9pt; padding:2px;');
        $droplistcategories = $selectCat->Output();
        // Get Usergroups
        $groups = getGroups();
        print_form_header('discuss_admin', 'categories', true);
 	    print_table_header("New Questions Category", 2);
        echo '<input type="hidden" name="action" value="save" />';
        echo '<tr><td class="alt1"><u><b>Parent category</u></b></td><td class="alt1">'.$droplistcategories.'</td></tr>';
        print_input_row("<u><b>Name</u></b>", "name", "", 250, 70);
        print_select_row("<b><u>Who can post</u></b><br /><div class='smallfont'>You can select multiple usergroups, or All, or None. If by mistake you select All and None, then All has priority and None will ignored.</div>", "usergroups[]", $groups, '', false, 8, true);
        print_submit_row();
        print_table_footer();
        return;
    }
    if ($_REQUEST['action'] == 'save')
    {
        // Let's clean inputs
        $vbulletin->input->clean_array_gpc('p', array(
            'parentid'     	  => TYPE_INT,
            'name'            => TYPE_STR,
            'usergroups'      => TYPE_ARRAY_INT
	    ));
        $parentid = $vbulletin->GPC['parentid'];
        $name = $db->escape_string($vbulletin->GPC['name']);
        $usergroups = $vbulletin->GPC['usergroups'];
        $userpost = implode(',', $usergroups);
        $db->query_write("INSERT INTO ". TABLE_PREFIX ."discuss_categories
                          SET name='$name',
                              displayorder='1',
                              parentid='$parentid',
                              userpost='$userpost'");
        $newid = $db->insert_id();
    }
    if ($_REQUEST['action'] == 'edit')
    {
        $catid = $_REQUEST["catid"];
        print_form_header('discuss_admin', 'categories', true);
 	    print_table_header("Edit Category", 2);
        $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."discuss_categories WHERE id=$catid");
        $parentid = $category["parentid"];
        // Get Usergroups
        $groups = getGroups();
        $selected = explode(",", $category["userpost"]);
        // Get Category Drop List
        $tablename = "".TABLE_PREFIX."categories";
        $selectCat = new SelectCategory('parentid', $tablename, 'true');
        $selectCat->SetFirstOption('Root Category', 0);
        $selectCat->SetSelected($category["parentid"]);
        $selectCat->SetMultiple(false, 15);
        $selectCat->SetStyle('width:330px;');
        $droplistcategories = $selectCat->Output();
	    echo '<input type="hidden" name="action" value="update" />';
	    echo '<input type="hidden" name="catid" value="'.$catid.'" />';
        echo '<input type="hidden" name="parentid" value="'.$parentid.'" />';
        echo '<tr><td class="alt1"><u><b>Parent category</u></b></td><td class="alt1">'.$droplistcategories.'</td></tr>';
        print_input_row("<u><b>Name</u></b>", "name", $category["name"], 250, 70);
        print_select_row("<b><u>Who can post</u></b><br /><div class='smallfont'>You can select multiple usergroups, or All, or None. If by mistake you select All and None, then All has priority and None will ignored.</div>", "usergroups[]", $groups, $selected, false, 8, true);
        print_submit_row();
        print_table_footer();
        return $catid;
    }
    if ($_REQUEST['action'] == 'update')
    {
        // Let's clean inputs
        $vbulletin->input->clean_array_gpc('p', array(
            'catid'     	  => TYPE_INT,
            'parentid'     	  => TYPE_INT,
            'name'            => TYPE_STR,
            'usergroups'      => TYPE_ARRAY_INT
	    ));
        $catid = $vbulletin->GPC['catid'];
        $parentid = $vbulletin->GPC['parentid'];
        $name = $db->escape_string($vbulletin->GPC['name']);
        $usergroups = $vbulletin->GPC['usergroups'];
        $userpost = implode(',', $usergroups);
        $db->query_write("UPDATE ". TABLE_PREFIX ."discuss_categories
                          SET name='$name',
                              parentid='$parentid',
                              userpost='$userpost' WHERE id=$catid");
        // Update Category Name in Albums
        $vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."discuss_questions SET categoryname='$name' WHERE categoryid=$catid");
    }
    if ($_REQUEST['action'] == 'delete')
    {
        $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
        // Now Delete the Category
        $db->query_write("DELETE FROM ". TABLE_PREFIX ."discuss_categories WHERE id=$catid");
    }
    if ($_REQUEST['action'] == 'updateorder')
    {
        $display = $_REQUEST["display"];
        $keys = array_keys($display);
        foreach($keys as $idx) {
          $order = $display[$idx];
          $db->query_write("UPDATE ".TABLE_PREFIX."discuss_categories SET displayorder=$order WHERE id=$idx");
        }
    }
    print_form_header("discuss_admin", "categories", true);
    print_table_header("Question Categories", 5);
    print_cells_row(array("Id", "Name", "Who can Post", "Order", "Action"), 1, 'tcat');
    $rows = getCategoriesList();
    echo $rows;
    echo '<input type="hidden" name="action" value="updateorder" />';
    print_table_footer(5, "<input type=\"submit\" class=\"button\" tabindex=\"1\" value=\" Save Display Order \" accesskey=\"s\" />" . construct_button_code(" Add New Category ", "discuss_admin.php?do=categories&action=insert&catid=$catid"));
}
print_cp_footer();
?>
