<?php
// Prepare and Send PM
function getSendPM($questionid,$templatename,$pmtitle,$fromuserid,$fromusername,$touserid)
{
    global $db, $vbulletin, $vbphrase, $vboptions;
    // Prepare Link
    $site_url = str_replace('http://', '', $vbulletin->options["bburl"]);
    // Find Item
    $question = $vbulletin->db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE id=$questionid LIMIT 1");
    // Album Title
    $questiontitle = '[URL='.$site_url.'/discuss.php?do=viewquestion&questionid='.$question["id"].']'.$question["title"].'[/URL]';
    $questiontitle_nolink = $question["title"];
    // Album Category
    $category = '[URL='.$site_url.'/discuss.php?do=main&catid='.$question["categoryid"].']'.$question["categoryname"].'[/URL]';
    $category_nolink = $question["categoryname"];
    // Album Owner
    $questionowner = '[URL='.$site_url.'/member.php?u='.$question["userid"].']'.$question["username"].'[/URL]';
    $questionowner_nolink = $question["username"];
    // Ger Username
    $get_username = $vbulletin->db->query_first("SELECT * FROM ".TABLE_PREFIX."user WHERE userid=$touserid LIMIT 1");
    $username = $get_username["username"];
    // Post Date
    $postdate_short = date($vbulletin->options["discuss_dateshort"], $question["postdate"]);
    $postdate_long = date($vbulletin->options["discuss_datelong"], $question["postdate"]);
    // Format Description
    require_once(DIR . '/includes/class_bbcode.php');
    $description = strip_bbcode($question['bodytext'], $stripquotes = false, $fast_and_dirty = false, $showlinks = false);
    $description = substr($description, 0, 200);
    $description = $vbulletin->input->clean($description, TYPE_NOHTML);
    // Signature
    $signature = $vbulletin->options["discuss_email_signature"];
    // Prepare Template
    $pmmessage = $templatename;
    $pmmessage = str_replace("{questiontitle}", $questiontitle, $pmmessage);
    $pmmessage = str_replace("{questiontitle_nolink}", $questiontitle_nolink, $pmmessage);
    $pmmessage = str_replace("{description}", $description, $pmmessage);
    $pmmessage = str_replace("{category}", $category, $pmmessage);
    $pmmessage = str_replace("{category_nolink}", $category_nolink, $pmmessage);
    $pmmessage = str_replace("{questionowner}", $questionowner, $pmmessage);
    $pmmessage = str_replace("{questionowner_nolink}", $questionowner_nolink, $pmmessage);
    $pmmessage = str_replace("{postdate_short}", $postdate_short, $pmmessage);
    $pmmessage = str_replace("{postdate_long}", $postdate_long, $pmmessage);
    $pmmessage = str_replace("{username}", $username, $pmmessage);
    $pmmessage = str_replace("{signature}", $signature, $pmmessage);
    // Send PM
    $timenow = time();
    $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "pmtext
                                         SET fromuserid = '$fromuserid',
                          			         fromusername = '$fromusername',
                                             title = '$pmtitle',
                                             message = '$pmmessage',
                                             touserarray = '',
                                             iconid = '0',
                                             dateline = '$timenow',
                                             showsignature = '0',
                                             allowsmilie = '1',
                                             reportthreadid = '0'");
    $messageid=$vbulletin->GPC['pmtextid'] = $vbulletin->db->insert_id();
    $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "pm
                                         SET pmtextid = '$messageid',
                       			             userid = '$touserid',
                                             folderid = '0',
                                             messageread = '0',
                                             parentpmid = '0'");
    $msguserid=$vbulletin->GPC['pmid'] = $vbulletin->db->insert_id();
    $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "user SET pmunread=pmunread+1 WHERE userid=$touserid");
    return;
}

// Update Category counter
function getUpdateCounter($catid,$type)
{
    global $db, $vbulletin;
	if(!$catid)
    {
		return;
	}
	if(!$type)
    {
		return;
	}
	$thiscat = $vbulletin->db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE id=$catid LIMIT 1");
    $thiscatid = $thiscat["id"];
    if($type == 1)
    {
       $vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."discuss_categories SET questions=questions+1, open=open+1 WHERE id=$thiscatid");
    }
    if($type == 2)
    {
       $vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."discuss_categories SET questions=questions-1, open=open-1 WHERE id=$thiscatid");
    }
	//- still have parents?
	if($thiscat['parentid'] != 0)
    {
		getUpdateCounter($thiscat['parentid'],$type);
	}
    return;
}
// Clean Editor
function getCleanInput($str)
{
	$message = htmlentities($str, ENT_QUOTES, 'UTF-8');
	$db_safe_message = mysql_real_escape_string($message);
    return $db_safe_message;
}

// Get Usernames for Search
function getUsernames()
{
  global $db, $vbulletin, $vbphrase, $vboptions, $usernameslist;
  $itemusernames = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_items GROUP BY userid ORDER BY username ASC");
  while ($itemusername = $db->fetch_array($itemusernames)) {
         // Set Option Values
	     $option = $itemusername['username'];
	     $optionid = $itemusername['userid'];
         // Create List
         $usernameslist .= '<option value="' . $optionid . '">' . $option . '</option>';
  }
  return $usernameslist;
}

// Get Category Structure for Menu
function getHorizontalCategories($catid,$blocks)
{
  global $db, $vbulletin, $vbphrase, $vboptions, $catid, $horizontalcategories, $horizontalcategoriesbit, $totalclassifieds, $hcategoryname, $subcategoriesbit, $totalsubclassifieds, $categoriesexist;

  $blockwidth = 100 / $blocks;
  $blockwidth = $blockwidth.'%';
  $total_hcategories = 0;
  $hcategories = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE parentid=$catid ORDER BY displayorder ASC, name ASC");
  $activecategory = 0;
  $totalsubcats = 5;
  $categoriesexist = 0;
  while($hcategory = $db->fetch_array($hcategories)) {
        $categoriesexist = 1;
        $activecategory = $hcategory["id"];
        $seolink = 'discuss.php?do=main&catid='.$activecategory;
		$totalopen = $hcategory["open"];
		$totalclosed = $hcategory["closed"];		
        $total_hcategories ++;
        if($total_hcategories == $blocks)
        {
           $total_hcategories = 0;
           $changeline = 1;
        } else {
           $changeline = 0;
        }
        if($totalsubcats != 0)
        {
           $showdots = 0;
           $total_subcategories = 0;
           if($totalsubcats == 99)
           {
              $subcategories = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE parentid=$activecategory ORDER BY displayorder ASC, name ASC");
           } else {
              $subcategories = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE parentid=$activecategory ORDER BY displayorder ASC, name ASC LIMIT $totalsubcats");
           }
           $subcategoriesbit = '';
           while($subcategory = $db->fetch_array($subcategories)) {
                 $activesubcategory = $subcategory["id"];
				$totalsubopen = $subcategory["open"];
				$totalsubclosed = $subcategory["closed"];
                 $total_subcategories ++;
                 if($total_subcategories == $totalsubcats)
                 {
                    $showdots = 1;
                 }
                 $seolink = 'discuss.php?do=main&catid='.$activesubcategory;
		         $templater = vB_Template::create('discuss_subcategories_bit');
		         $templater->register('subcategoryid', $subcategory[id]);
		         $templater->register('subcategoryname', $subcategory[name]);
                 $templater->register('subseolink', $subseolink);
                 $templater->register('totalsubopen', $totalsubopen);
				 $templater->register('totalsubclosed', $totalsubclosed);
                 $templater->register('showdots', $showdots);
		         $subcategoriesbit .= $templater->render();
           }
        }
		$templater = vB_Template::create('discuss_horizontal_categories_bit');
		$templater->register('blockwidth', $blockwidth);
        $templater->register('changeline', $changeline);
		$templater->register('hcategoryid', $hcategory[id]);
		$templater->register('hcategoryname', $hcategory[name]);
        $templater->register('seolink', $seolink);
        $templater->register('totalopen', $totalopen);
		$templater->register('totalclosed', $totalclosed);
        $templater->register('subcategoriesbit', $subcategoriesbit);
		$horizontalcategoriesbit .= $templater->render();
  }
  $templater = vB_Template::create('discuss_horizontal_categories');
  $templater->register('horizontalcategoriesbit', $horizontalcategoriesbit);
  $horizontalcategories .= $templater->render();
  return;
}

function getCountRecords($activecategory)
{
	global $db, $vbulletin, $vbphrase, $vboptions, $catid, $totalopen, $totalclosed;
	$totalopen = 0;
	$totalclosed = 0;
	$get_records = '';
	$category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."discuss_categories WHERE id='$activecategory' LIMIT 1");
	$parentid = $category["parentid"];
	// Remove subcategories too
	$deletedId = array();
	_getCountChild($deletedId, $activecategory);
	$idList = "'". implode("','", $deletedId)."'";
	$get_records = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."discuss_questions WHERE categoryid IN ($idList) AND approved=1");
	while($get_record = $vbulletin->db->fetch_array($get_records)) {
		if($get_record["resolved"] == 1)
		{
			$totalclosed ++;
		} else {
			$totalopen ++;
		}
	}
	// Go back
	$activecategory = $parentid;
	return;
}

function _getCountChild(&$outArray, $parentId) {
	global $db, $vbulletin, $vbphrase, $vboptions, $activecategory;
	if($parentId > 0)
		$outArray[] = $parentId;
	$subcategories = $db->query_read("SELECT id FROM ". TABLE_PREFIX ."discuss_categories WHERE parentid=".$parentId."");
	if(!$subcategories)
    {
		return;
    }
	while($category = $db->fetch_array($subcategories)) {
			_getCountChild($outArray, $category['id']);
	}
}

function getCountSubRecords($activesubcategory)
{
  global $db, $vbulletin, $vbphrase, $vboptions, $catid, $totalsubclassifieds;
  $totalsubclassifieds = 0;
  $get_records = '';
  $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."discuss_categories WHERE id='$activesubcategory' LIMIT 1");
  $parentid = $category["parentid"];
  // Remove subcategories too
  $deletedId = array();
  _getCountSubChild($deletedId, $activesubcategory);
  $idList = "'". implode("','", $deletedId)."'";
  $get_records = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."discuss_questions WHERE categoryid IN ($idList) AND approved=1 AND status=1");
  $totalsubclassifieds = $db->num_rows($get_records);
  // Go back
  $activesubcategory = $parentid;
  return $totalsubclassifieds;
}

function _getCountSubChild(&$outArray, $parentId) {
	global $db, $vbulletin, $vbphrase, $vboptions, $activesubcategory;
	if($parentId > 0)
		$outArray[] = $parentId;
	$subsubcategories = $db->query_read("SELECT id FROM ". TABLE_PREFIX ."discuss_categories WHERE parentid=".$parentId."");
	if(!$subsubcategories)
    {
		return;
    }
	while($category = $db->fetch_array($subsubcategories)) {
			_getCountSubChild($outArray, $category['id']);
	}
}
// Get SEO friendly URL
function getSEO(&$this_seolink, $catid)
{
    global $db, $vbulletin, $vbphrase, $vboptions;
	if($catid <= 0)
    {
		$this_seolink = $vbphrase["discuss_global"].'.html';
		return $this_seolink;
	}
	$seocat = $vbulletin->db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE id=$catid LIMIT 1");
	if(empty($seocat['seotitle']))
    {
       $seocat['seotitle'] = str_replace(" ", "-", $seocat["name"]);
    } else {
       $seocat['seotitle'] = str_replace(" ", "-", $seocat["seotitle"]);
    }
	if(empty($this_seolink))
    {
		$this_seolink = $seocat['seotitle'];
	} else {
		$this_seolink = $seocat['seotitle'].'/'.$this_seolink;
    }
	//- still have parents?
	if($seocat['parentid'] != 0)
    {
		getSEO($this_seolink, $seocat['parentid']);
	} else {
		$this_seolink = $this_seolink;
	}
    return $this_seolink;
}
function getOrderList($start, $end, $selected)
{
    global $options;
	$options = "";
	for($i = $start; $i <= $end; $i++) {
		$sel = ($selected == $i ? "selected" : "");
		$options .= "<option value=\"$i\" $sel >$i</option>\n";
	}
	return $options;
}
// Get Category Name
function getCategoryName($id)
{
  global $db, $vbulletin, $vbphrase, $vboptions;
  $category = $db->query_first("SELECT name FROM ".TABLE_PREFIX."discuss_categories WHERE id=$id LIMIT 1");
  return $category["name"];
}
// Get User Name
function getUserName($id)
{
  global $db, $vbulletin, $vbphrase, $vboptions;
  $user = $vbulletin->db->query_first("SELECT username FROM ".TABLE_PREFIX."user WHERE userid=$id LIMIT 1");
  return $user["username"];
}
// Shorter Title
function getTitle($title)
{
    global $db, $vbulletin, $vbphrase, $vboptions, $cutofftitle;
	if(empty($title))
    {
       $cutofftitle = '';
       return $cutofftitle;
    }
    $cutofftitle = $vbulletin->input->clean(substr($title, 0, $vbulletin->options["discuss_max_title"]), TYPE_NOHTML);
	return $cutofftitle;
}
// Categories List
function getCategoriesList()
{
    global $rows;
	_getCategories($rows, 0);
	return $rows;
}
// Function for Categories List
function _getCategories(&$output, $parentId, $level = 0)
{
    global $db, $vbulletin, $vbphrase, $vboptions;
	$qry = $vbulletin->db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE parentid=$parentId GROUP BY id, name, displayorder ORDER BY displayorder ASC, name ASC");
	while($row = $vbulletin->db->fetch_array($qry)) {
          $catid = $row["id"];
          // Check if there are Subcategories to inactivate Delete
          $subqry = $vbulletin->db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE parentid=$catid");
          $subcategories = $vbulletin->db->num_rows($subqry);
          $output .= '<tr><td class="alt1" align="right">'.$row['id'].'</td>';
		  $output .= '<td class="alt1">'.str_repeat('&nbsp;', $level * 4).'&raquo; '.$row['name'].'</td>';
          if($row["userpost"] == 0)
          {
             $output .= '<td class="alt1" align="center">All</td>';
          } elseif ($row["userpost"] == 999) {
             $output .= '<td class="alt1" align="center">None</td>';
          } else {
             $output .= '<td class="alt1" align="center">'.$row['userpost'].'</td>';
          }
		  $output .= '<td class="alt1">'.str_repeat('&nbsp;', $level * 4).'<input type="text" size="3" name="display['.$row['id'].']" value="'.$row['displayorder'].'"></td>';
		  $output .= '<td class="alt1" align="center">';
          $output .= '<select class="bginput" name="action" onChange="actionCategory(this, '.$row["id"].')">
                      <option value="0">Select..</option>
                      <option value="1">Edit</option>';
          if($subcategories == 0)
          {
             $output .= '<option value="2">Delete</option>';
          }
          $output .= '</select>';
          $output .= '</td></tr>';
		  _getCategories($output, $row['id'], $level+1);
	}
}

function getNoLinkNavBar(&$output, $catid)
{
	global $db, $vbulletin, $vbphrase, $vboptions;

	if($catid <= 0) {
		$output = '';
		return $output;
	}
	$qry = $vbulletin->db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE id = $catid");
	$row = $vbulletin->db->fetch_array($qry);

	if(empty($output))
    {
		$output = $row['name'];
	} else {
		$output = $row['name'].'&raquo; ' . $output;
    }
	//- still have parents?
	if($row['parentid'] != 0)
    {
		getNoLinkNavBar($output, $row['parentid']);
	} else {
		$output = $output;
	}
    return $output;
}

// Check if Category Watch exists for current viewer
function getFollowUp($catid,$viewerid)
{
  global $db, $vbulletin, $vbphrase, $vboptions, $followup_exists;

  $followup_exists = 0;
  if(!$catid)
  {
     return;
  }
  if(!$viewerid)
  {
     return;
  }
  $qry = $db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_watch WHERE userid=$viewerid AND categoryid=$catid");
  if(!$qry)
  {
      return;
  } else {
      $followup_exists = 1;
  }
  return $followup_exists;
}
// Get Subcategories
function _getChildId(&$outArray, $parentId) {
	global $db, $vbulletin, $vbphrase, $vboptions, $catid;
	if($parentId > 0)
		$outArray[] = $parentId;
	$subcategories = $vbulletin->db->query_read("SELECT id FROM ". TABLE_PREFIX ."discuss_categories WHERE parentid=".$parentId."");
	if(!$subcategories)
    {
		return;
    }
	while($category = $vbulletin->db->fetch_array($subcategories)) {
			_getChildId($outArray, $category['id']);
	}
}

function getCategories($catid)
{
  global $db, $vbulletin, $vbphrase, $vboptions, $html, $catid;
  $categories = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE parentid=$catid ORDER BY displayorder ASC, name ASC");
  $html = '';
  if($db->num_rows($categories) != 0) {
     $html = '<table width="100%">';
     while($category = $db->fetch_array($categories)) {
           $id = $category["id"];
           $name = $category["name"];
           $title = sanitize_title($category["name"]);
           $html .= '<tr><td><div class="smallfont"><strong>&raquo;&nbsp;';
           $html .= '<a href=articles.php?'.$vbulletin->session->vars['sessionurl'].'do=directory&catid='.$category["id"].'&title='.$title.'>'.$category["name"].'</a>';
    	   $html .= '</strong></div></td></tr>';
     }
     $html .= '</table>';
  }
  return $html;
}

// Get any level of Subcategories
function getBrowseSubCats($activecategory)
{
  global $db, $vbulletin, $vbphrase, $vboptions, $catid, $totalarticles;
  $totalarticles = 0;
  $get_records = '';
  $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."discuss_categories WHERE id='$activecategory' LIMIT 1");
  $parentid = $category["parentid"];
  // Remove subcategories too
  $deletedId = array();
  _getBrowseSubCats($deletedId, $activecategory);
  $idList = "'". implode("','", $deletedId)."'";
  $get_records = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."discuss_questions WHERE categoryid IN ($idList) AND approved=1 AND status=1");
  $totalarticles = $db->num_rows($get_records);
  // Go back
  $activecategory = $parentid;
  return $totalarticles;
}

function _getBrowseSubCats(&$outArray, $parentId) {
	global $db, $vbulletin, $vbphrase, $vboptions, $activecategory;
	if($parentId > 0)
		$outArray[] = $parentId;
	$subcategories = $db->query_read("SELECT id FROM ". TABLE_PREFIX ."discuss_categories WHERE parentid=".$parentId."");
	if(!$subcategories)
    {
		return;
    }
	while($category = $db->fetch_array($subcategories)) {
			_getCountChild($outArray, $category['id']);
	}
}



// Get Usergroups
function getGroups()
{
  global $db, $vbulletin, $vbphrase, $vboptions, $usergroups;
  $usergroups = array();
  $disallowgroups = array('1','3','4','8');
  $excludegroups = implode($disallowgroups, ',');
  $groups = $db->query_read("SELECT * FROM ".TABLE_PREFIX."usergroup WHERE usergroupid NOT IN ($excludegroups) ORDER BY usergroupid ASC");
  $usergroups[0] = 'All Usergroups';
  $usergroups[999] = 'None Usergroup';
  while ($group = $db->fetch_array($groups)) {
         $usergroups[$group['usergroupid']] = $group['title'];
  }
  return $usergroups;
}

// Get Selected Usergroups
function getEditUserGroups($selected)
{
  global $db, $vbulletin, $vbphrase, $usergroupoptions;
  $usergroupoptions = '';
  $dataselected = array();
  $dataselected = explode(",", $selected);
  $optionid = 0;
  if(in_array($optionid, $dataselected))
  {
     $usergroupoptions .='<option value="0" selected="selected">All Usergroups</option>';
  } else {
     $usergroupoptions .='<option value="0">All Usergroups</option>';
  }
  $optionid = 999;
  if(in_array($optionid, $dataselected))
  {
     $usergroupoptions .='<option value="999" selected="selected">None Usergroup</option>';
  } else {
     $usergroupoptions .='<option value="999">None Usergroup</option>';
  }
  $disallowgroups = array('1','3','4','8');
  $excludegroups = implode($disallowgroups, ',');
  $groups = $db->query_read("SELECT * FROM ".TABLE_PREFIX."usergroup WHERE usergroupid NOT IN ($excludegroups) ORDER BY usergroupid ASC");
  while ($group = $db->fetch_array($groups)) {
         // Set Option Values
	     $option = $group['title'];
	     $optionid = $group['usergroupid'];
         // Make Option Selected If Needed
         unset ($optionselected);
         if(in_array($optionid, $dataselected))
         {
            $optionselected = " selected=selected";
         }
         // Create List
         $usergroupoptions .= '<option value="' . $optionid . '"' . $optionselected . '>' . $option . '</option>';
  }
  return $usergroupoptions;
}
// Get Custom NavBar
function getNavBar(&$output, $catid) {
	global $db, $vbulletin, $vbphrase, $vboptions, $output, $seolink;
	if($catid < 0) {
		$output = '';
		return $output;
	}
    $arrow_icon = '<img border="0" src="discuss/images/navbit-arrow.png">';
	$qry = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE id = $catid");
	$row = $db->fetch_array($qry);
    if($vbulletin->options["discuss_seourls"] == 1)
    {
       $url_output = '';
       $seolink = getSEO($url_output,$row["id"]);
       $seolink = $vbphrase["discuss_global"].'/'.$row["id"].'/'.$seolink.'.html';
    } else {
       $seolink = 'discuss.php?do=main&catid='.$row["id"];
    }
	if(trim($output) == '')
    {
		$output = '<a href="'.$seolink.'">'.$row['name'].'</a>';
	} else {
		$output = '<a href="'.$seolink.'">'.$row['name'].'</a>&nbsp;&nbsp;'.$arrow_icon.'&nbsp;&nbsp;'.$output;
    }
	//- still have parents?
	if($row['parentid'] != 0) {
		getNavBar($output, $row['parentid']);
	} else {
		$output = $output;
	}
    return $output;
}

class SelectCategory {

	var $Name;
	var $SelectedId;
	var $IsMultiple;
	var $MultipleSize;
	var $ClassName;
	var $Id;
	var $Style;
	var $RootId;

	var $output;
	var $srcTable;
    var $SearchForm;
	var $firstOption;
	var $attributes;

	function SelectCategory($name, $table, $search) {
		$this->Name = $name;
		$this->SelectedId = '';
		$this->IsMultiple = false;
		$this->MultipleSize = 5;
		$this->FirstOption = array('value' => '', 'text' => '');
		$this->ClassName = '' ;
		$this->Id = '';
		$this->Style = '';
		$this->RootId = 0;

		$this->output = '';
		$this->srcTable = $table;
        $this->SearchForm = $search;
	}

	function Output() {
		$options = '';
		$this->_getCategory($options, $this->RootId);

		$attributes = $this->_getAttributes();

        if(($this->SearchForm) == 'true')
        {
            $output = '<select '.$attributes.' onchange="setFilter()">'.$options.'</select>';
        } else {
		    $output = '<select '.$attributes.'>'.$options.'</select>';
        }
		return $output;
	}

	function SetFirstOption($text, $value) {
		$this->firstOption = array('value' => '', 'text' => '');
		$this->firstOption['value']	= $value;
		$this->firstOption['text'] = $text;
	}

	function SetMultiple($active, $rows) {
		$this->IsMultiple = $active;
		$this->MultipleSize = $rows;
	}

    function SetStyle($value)
    {
        $this->Style = $value;
    }

    function SetClass($value)
    {
        $this->ClassName = $value;
    }

	function SetSelected($catid) {
		$this->SelectedId = $catid;
	}

	function _getAttributes() {
		$tmpAtt = array();

		$tmpAtt[] = 'name="'.$this->Name.'"';

		if($this->IsMultiple)
			$tmpAtt[] = 'multiple size="'.$this->MultipleSize.'"';

		if(trim($this->ClassName) != '')
			$tmpAtt[] = 'class="'.$this->ClassName.'"';

		if(trim($this->Style) != '')
			$tmpAtt[] = 'style="'.$this->Style.'"';

		if(count($tmpAtt) > 0)
        {
			$return = implode(' ', $tmpAtt);
		} else {
			$return = '';
        }
		return $return;
	}

	function _getCategory(&$options, $rootId, $level = 0) {
    global $db, $vbulletin, $vbphrase, $vboptions, $catid;
		if(is_array($this->firstOption) && trim($options) == '') {
			$options .= '<option value="'.$this->firstOption['value'].'">'.
						$this->firstOption['text'].'</option>';
		}

		$qry = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE parentid=$rootId ORDER BY displayorder ASC, name ASC");
			while($row = $db->fetch_array($qry)) {
              if(is_array($this->SelectedId))
              {
				if(in_array($row['id'],$this->SelectedId))
                {
					$selected = ' selected';
				} else {
					$selected = '';
                }
              } else {
        		if($row['id'] == $this->SelectedId)
                {
            	    $selected = ' selected';
				} else {
					$selected = '';
                }
              }
              if(($this->SearchForm) == 'true')
              {
   	             $options .= '<option value="'.$row['id'].'" '.$selected.'>'.str_repeat('&nbsp;', $level*4).'- '.$row['name']."</option>\n";
                 $search = 0;
              } else {
                  $currentcat = $row['id'];
        		  $checkactive = $db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_categories WHERE id=$currentcat LIMIT 1");
                  $whocanpost = trim($checkactive["userpost"]);
                  $usergroups = array();
                  $usergroups = explode(",", $whocanpost);
                  if(in_array('0', $usergroups))
                  {
				     $options .= '<option value="'.$row['id'].'" '.$selected.'>'.str_repeat('&nbsp;', $level*4).'- '.$row['name']."</option>\n";
                  } else {
                     if(in_array('999', $usergroups))
                     {
				        $options .= '<option value="'.$row['id'].'" disabled="disabled">'.str_repeat('&nbsp;', $level*4).'- '.$row['name']."</option>\n";
                     } else {
                        if(in_array($vbulletin->userinfo["usergroupid"], $usergroups))
                        {
				           $options .= '<option value="'.$row['id'].'" '.$selected.'>'.str_repeat('&nbsp;', $level*4).'- '.$row['name']."</option>\n";
                        } else {
				           $options .= '<option value="'.$row['id'].'" disabled="disabled">'.str_repeat('&nbsp;', $level*4).'- '.$row['name']."</option>\n";
                        }
                     }
                  }
                }
              	$this->_getCategory($options, $row['id'], $level+1);
			}
	}
}


function parseBbCode($bbcode, $limit = 0)
{
  global $db, $vbulletin, $vbphrase, $vboptions;
  require_once(DIR . '/includes/class_bbcode.php');
  $parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());
  $text = $parser->do_parse($bbcode);
  if($limit != 0) {
  	if(strlen($text) > $limit)
  		$text = substr($text, 0, $limit).' ...';
  	}
    return $text;
}


function time_stamp($session_time)
{
    global $db, $vbulletin, $vbphrase, $vboptions;
    $time_difference = time() - $session_time ;
    $seconds = $time_difference ;
    $minutes = round($time_difference / 60 );
    $hours = round($time_difference / 3600 );
    $days = round($time_difference / 86400 );
    $weeks = round($time_difference / 604800 );
    $months = round($time_difference / 2419200 );
    $years = round($time_difference / 29030400 );
    if($seconds <= 60)
    {
        $timeframe = "".$seconds." ".$vbphrase["discuss_sa"]."";
    }
    else if($minutes <=60)
    {
       if($minutes==1)
       {
          $timeframe = $vbphrase["discuss_1ma"];
       } else {
          $timeframe = "".$minutes." ".$vbphrase["discuss_ma"]."";
       }
    }
    else if($hours <=24)
    {
       if($hours==1)
       {
          $timeframe = $vbphrase["discuss_1ha"];
       } else {
          $timeframe = "".$hours." ".$vbphrase["discuss_ha"]."";
       }
    }
    else if($days <=7)
    {
       if($days==1)
       {
          $timeframe = $vbphrase["discuss_1da"];
       } else {
          $timeframe = "".$days." ".$vbphrase["discuss_da"]."";
       }
    }
    else if($weeks <=4)
    {
       if($weeks==1)
       {
          $timeframe = $vbphrase["discuss_1wa"];
       } else {
          $timeframe = "".$weeks." ".$vbphrase["discuss_wa"]."";
       }
    }
    else if($months <=12)
    {
       if($months==1)
       {
          $timeframe = $vbphrase["discuss_1moa"];
       } else {
          $timeframe = "".$months." ".$vbphrase["discuss_moa"]."";
       }
    } else {
       if($years==1)
       {
          $timeframe = $vbphrase["discuss_1ya"];
       } else {
          $timeframe = "".$years." ".$vbphrase["discuss_ya"]."";
       }
    }
    return $timeframe;
}
?>
