<?php
	//////////////////////////////////////////////////////////////////////////////
	///// SET PHP ENVIRONMENT
	//////////////////////////////////////////////////////////////////////////////
	error_reporting(E_ALL & ~E_NOTICE);
	//////////////////////////////////////////////////////////////////////////////
	///// REQUIRE BACK-END
	//////////////////////////////////////////////////////////////////////////////
	if (!is_object($vbulletin->db))
	{
		exit;
	}
	///// Set Globals
	global $db, $vbulletin, $vbphrase, $vboptions, $timenow;
	///// Load Functions
	require_once(DIR . '/discuss/includes/functions.php');
	//////////////////////////////////////////////////////////////////////////////
	///// UPDATE CATEGORIES WITH QUESTIONS
	//////////////////////////////////////////////////////////////////////////////
	$sql_categories = $vbulletin->db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_categories ORDER BY id ASC");
	while ($category = $vbulletin->db->fetch_array($sql_categories)) {
		   $categoryid = $category["id"];
		   $SubIds = array();
		   $getSub = _getChildId($SubIds, $categoryid);
		   $categories = implode($SubIds, ', ');
		   $open = 0;
		   $closed = 0;
		   $totalquestions = 0;
		   $sql_questions = $vbulletin->db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE categoryid IN ($categories) AND approved=1 AND hidden=0");
		   while ($question = $vbulletin->db->fetch_array($sql_questions)) {
				  if ($question["resolved"] == 1)
				  {
					  $closed ++;
				  } else {
					  $open ++;
				  }	
				  $totalquestions = $open + $closed;
				  $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "discuss_categories
													SET open = '$open',
														closed = '$closed',
														questions = '$totalquestions' WHERE id=$categoryid");
			
			}
	}
	//////////////////////////////////////////////////////////////////////////////
	///// UPDATE QUESTIONS WITH REPLIES
	//////////////////////////////////////////////////////////////////////////////
	$questions = $vbulletin->db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE approved=1 AND resolved=0 AND hidden=0 ORDER BY id ASC");
    while($question = $vbulletin->db->fetch_array($questions)) {
          $questionid = $question["id"];
		  $sql_replies = $vbulletin->db->query_first("SELECT COUNT(id) AS totalreplies FROM ".TABLE_PREFIX."discuss_replies WHERE questionid=$questionid");
		  $replies = $sql_replies["totalreplies"];
          $vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."discuss_questions SET replies=$replies WHERE id=$questionid");
	}
?>
